/* IRIX 5.x */

#define IS_IRIX5

/* generic porting functions -- directories, getcwd(), strchr(), bzero() etc. */

#define USE_DIRENT		/* instead of struct direct (SYSV) */
#define USE_GETCWD		/* instead of getwd() (SYSV) */
#define NO_BFUNCTIONS		/* use memzero, etc. instaed of bzero, etc. (SYSV) */

/* wait() and status */

#define INT_STATUS		/* status (from wait()) is of type int (BSD) */
#define USE_WAITPID		/* instead of wait3() (SYSV) */

/* set-user-id; use seteuid(), setresuid(), setreuid(), or setuid() (in that order) */

#define USE_SETEUID            	/* BSD, SVR4 */
#undef USE_SETRESUID		/* HP/UX */
#undef USE_SETREUID		/* BSD */

/* signal stuff */

#define SIG_RETURN_TYPE void	/* signal() handlers should return this type (BSD) */
#define USE_SIGPROCMASK		/* instead of sigsetmask() (SYSV) */

/* process group stuff */

#undef USE_KILLPG		/* use killpg() instead of kill() (BSD) */
#define USE_SETSID		/* use setsid() instead of setpgrp() (SYSV) */
#define GETPGRP_VOID_ARGS	/* getpgrp() takes no arguments (SYSV) */

/* handling terminal modes */

#undef USE_SGTTYB	/* use the sgttyb structure and ioctl() (BSD) */
#define USE_TERMIOS	/* use the termios structure and tcget/setattr() (SYSV) */
#ifdef USE_TERMIOS	/* these don't matter unless USE_TERMIOS is defined */
# define USE_TCGETATTR	/* instead of ioctl(fd, TCGETS, tios) (SYSV - termios) */
# define USE_TCSETATTR	/* instead of ioctl(fd, TCSETS, tios) (SYSV - termios) */
#endif

/* used in lpr_canprint.c to identify executable files */

#undef USE_A_OUT_H	/* use <a.out.h> to get OMAGIC, NMAGIC etc. macro */
#define USE_EXECHDR_H	/* use <sys/exechdr.h> to get OMAGIC, NMAGIC etc. macro */

/* misc. stuff */

#define USE_FCNTL_LOCK	/* fcntl() locking works over NFS - preferred */
#undef PROTO_SPRINTF	/* declare a prototype for sprintf() (BSD) */
#undef HAS_UNSETENV     /* is there an unsetenv() function? */
#define TERMCAP		/* use termcap code to clear screen for lpq in periodic mode */
#define HAVE_RRESVPORT	/* is there a rresvport() function? (BSD, SVR4) */

/* put #includes here */
